diff -urN sbcl-0.8.16/contrib/sb-aclrepl/inspect.lisp sbcl-0.8.16.patched/contrib/sb-aclrepl/inspect.lisp
--- sbcl-0.8.16/contrib/sb-aclrepl/inspect.lisp	2004-06-29 10:50:57.000000000 +0200
+++ sbcl-0.8.16.patched/contrib/sb-aclrepl/inspect.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -681,7 +681,7 @@
   (description-maybe-internals "character ~W char-code #x~2,'0X"
 			       (list object (char-code object))
 			       "[#x~8,'0X]"
-			       (logior sb-vm:base-char-widetag 
+			       (logior sb-vm:character-widetag 
 				       (ash (char-code object)
 					    sb-vm:n-widetag-bits))))
 
diff -urN sbcl-0.8.16/contrib/sb-simple-streams/impl.lisp sbcl-0.8.16.patched/contrib/sb-simple-streams/impl.lisp
--- sbcl-0.8.16/contrib/sb-simple-streams/impl.lisp	2004-08-13 19:35:44.000000000 +0200
+++ sbcl-0.8.16.patched/contrib/sb-simple-streams/impl.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -173,7 +173,7 @@
 	   (index 0)			; current index in current buffer
 	   (total 0))			; total characters
       (declare (type simple-stream encap)
-	       (type simple-base-string cbuf)
+	       (type simple-string cbuf)
 	       (type cons bufs tail)
 	       (type sb-int:index index total))
       (loop
@@ -200,7 +200,7 @@
 		(do ((list bufs (cdr list)))
 		    ((eq list tail))
 		  (let ((buf (car list)))
-		    (declare (type simple-base-string buf))
+		    (declare (type simple-string buf))
 		    (replace cbuf buf :start1 idx)
 		    (incf idx (length buf)))))
 	      (return (values (sb-kernel:shrink-vector cbuf total)
@@ -210,7 +210,7 @@
 		  (index 0))
 	      (declare (type sb-int:index index))
 	      (dolist (buf bufs)
-		(declare (type simple-base-string buf))
+		(declare (type simple-string buf))
 		(replace string buf :start1 index)
 		(incf index (length buf)))
 	      (return  (values string (eq done :eof)))))
diff -urN sbcl-0.8.16/make-host-1.sh sbcl-0.8.16.patched/make-host-1.sh
--- sbcl-0.8.16/make-host-1.sh	2004-02-27 10:41:37.000000000 +0100
+++ sbcl-0.8.16.patched/make-host-1.sh	2004-10-26 17:08:22.000000000 +0200
@@ -43,6 +43,9 @@
 	(when (find :sb-test *shebang-features*)
 	  (load "tests/type.before-xc.lisp")
 	  (load "tests/info.before-xc.lisp"))
+        (load "tools-for-build/ucd.lisp")
+        (sb-cold::slurp-ucd)
+        (sb-cold::output)
         (host-cload-stem "src/compiler/generic/genesis")
 	(sb!vm:genesis :c-header-dir-name "src/runtime/genesis")
         #+cmu (ext:quit)
diff -urN sbcl-0.8.16/package-data-list.lisp-expr sbcl-0.8.16.patched/package-data-list.lisp-expr
--- sbcl-0.8.16/package-data-list.lisp-expr	2004-09-13 09:14:38.000000000 +0200
+++ sbcl-0.8.16.patched/package-data-list.lisp-expr	2004-10-26 17:08:22.000000000 +0200
@@ -63,6 +63,7 @@
 	     "SAP-ALIEN" "SHORT" "SIGNED" "SLOT" "STRUCT"
 	     "UNSIGNED"
 	     "UNSIGNED-CHAR" "UNSIGNED-INT" "UNSIGNED-LONG" "UNSIGNED-SHORT"
+             "UTF8-STRING"
 	     "VOID"
 	     "WITH-ALIEN"))
 
@@ -902,7 +903,7 @@
 
 	       ;; various internal defaults
 	       "DEFAULT-INIT-CHAR" "*DEFAULT-INIT-CHAR-FORM*"
-	       "*LOAD-SOURCE-DEFAULT-TYPE*"
+	       "*LOAD-SOURCE-DEFAULT-TYPE*" "BASE-CHAR-CODE-LIMIT"
 
 	       ;; hash caches
 	       "DEFINE-HASH-CACHE"
@@ -1118,7 +1119,11 @@
                "BINDING-STACK-POINTER-SAP" "BIT-BASH-COPY" "BIT-INDEX"
                "BOGUS-ARG-TO-VALUES-LIST-ERROR" "BOOLE-CODE"
                "BOUNDING-INDICES-BAD-ERROR" "BYTE-SPECIFIER" "%BYTE-BLT"
-               "CALLABLE" "CASE-BODY-ERROR" "CHARPOS"
+               "CALLABLE" "CASE-BODY-ERROR"
+	       "CHARACTER-SET" "CHARACTER-SET-TYPE"
+	       "CHARACTER-SET-TYPE-PAIRS"
+	       "CHARACTER-STRING-P"
+	       "CHARPOS"
                "CHECK-FOR-CIRCULARITY" "CHECK-TYPE-ERROR" "CLOSED-FLAME"
                "CODE-COMPONENT" "CODE-COMPONENT-P" "CODE-DEBUG-INFO"
                "CODE-HEADER-REF" "CODE-HEADER-SET" "CODE-INSTRUCTIONS"
@@ -1150,6 +1155,7 @@
                "FLOAT-WAIT" "DYNAMIC-SPACE-FREE-POINTER" "DYNAMIC-USAGE"
                "EFFECTIVE-FIND-POSITION-TEST"
                "EFFECTIVE-FIND-POSITION-KEY" "ERROR-NUMBER-OR-LOSE"
+	       "EXTENDED-CHAR-P"
                "FAILED-%WITH-ARRAY-DATA" "FDEFINITION-OBJECT"
                "FDOCUMENTATION" "FILENAME"
                "FIND-AND-INIT-OR-CHECK-LAYOUT" "FLOAT-EXPONENT"
@@ -1218,9 +1224,10 @@
                "NUMERIC-TYPE-CLASS" "NUMERIC-TYPE-COMPLEXP"
                "NUMERIC-TYPE-EQUAL" "NUMERIC-TYPE-FORMAT"
                "NUMERIC-TYPE-HIGH" "NUMERIC-TYPE-LOW" "NUMERIC-TYPE-P"
-               "OBJECT-NOT-ARRAY-ERROR" "OBJECT-NOT-BASE-CHAR-ERROR"
+               "OBJECT-NOT-ARRAY-ERROR" "OBJECT-NOT-CHARACTER-ERROR"
                "OBJECT-NOT-BASE-STRING-ERROR" "OBJECT-NOT-BIGNUM-ERROR"
-               "OBJECT-NOT-BIT-VECTOR-ERROR" "OBJECT-NOT-COMPLEX-ERROR"
+               "OBJECT-NOT-BIT-VECTOR-ERROR"
+	       "OBJECT-NOT-CHARACTER-STRING-ERROR" "OBJECT-NOT-COMPLEX-ERROR"
                "OBJECT-NOT-COMPLEX-FLOAT-ERROR"
                "OBJECT-NOT-COMPLEX-SINGLE-FLOAT-ERROR"
                #!+long-float "OBJECT-NOT-COMPLEX-LONG-FLOAT-ERROR"
@@ -1286,6 +1293,7 @@
                "OBJECT-NOT-SIMPLE-ARRAY-SIGNED-BYTE-8-ERROR"
                "OBJECT-NOT-SIMPLE-BIT-VECTOR-ERROR"
                "OBJECT-NOT-SIMPLE-BASE-STRING-ERROR"
+	       "OBJECT-NOT-SIMPLE-CHARACTER-STRING-ERROR"
                "OBJECT-NOT-SIMPLE-STRING-ERROR"
                "OBJECT-NOT-SIMPLE-VECTOR-ERROR"
                "OBJECT-NOT-SINGLE-FLOAT-ERROR" "OBJECT-NOT-STRING-ERROR"
@@ -1294,7 +1302,9 @@
                "OBJECT-NOT-UNSIGNED-BYTE-32-ERROR"
                ;; FIXME: 32/64-bit issues
                "OBJECT-NOT-UNSIGNED-BYTE-64-ERROR"
-               "OBJECT-NOT-VECTOR-ERROR" "OBJECT-NOT-WEAK-POINTER-ERROR"
+               "OBJECT-NOT-VECTOR-ERROR"
+	       "OBJECT-NOT-VECTOR-NIL-ERROR"
+	       "OBJECT-NOT-WEAK-POINTER-ERROR"
                "ODD-KEY-ARGS-ERROR" "OUTPUT-OBJECT" "OUTPUT-UGLY-OBJECT"
                "PACKAGE-DESIGNATOR" "PACKAGE-DOC-STRING"
                "PACKAGE-HASHTABLE-SIZE" "PACKAGE-HASHTABLE-FREE"
@@ -1341,6 +1351,7 @@
                "SIMPLE-ARRAY-SIGNED-BYTE-61-P"
                "SIMPLE-ARRAY-SIGNED-BYTE-64-P"
                "SIMPLE-ARRAY-SIGNED-BYTE-8-P" "SIMPLE-BASE-STRING-P"
+	       "SIMPLE-CHARACTER-STRING-P"
                "SIMPLE-PACKAGE-ERROR" "SIMPLE-UNBOXED-ARRAY"
                "SINGLE-FLOAT-BITS" "SINGLE-FLOAT-EXPONENT"
                "SINGLE-FLOAT-INT-EXPONENT" "SINGLE-FLOAT-SIGNIFICAND"
@@ -1888,7 +1899,7 @@
 	       "EUSERS" "EVICEERR" "EVICEOP" "EWOULDBLOCK" "EXDEV"
 
 	       "FD-ISSET" "FD-SET" "LTCHARS" "UNIX-FAST-SELECT"
-	       "UNIX-FILE-KIND" "UNIX-KILL" 
+	       "UNIX-FILE-KIND" "UNIX-KILL" "CODESET"
 	       "TCSETPGRP" "FD-ZERO" "FD-CLR" "CHECK" "UNIX-RESOLVE-LINKS"
 	       "FD-SETSIZE" "TCGETPGRP" "UNIX-FAST-GETRUSAGE"
 	       "UNIX-SIMPLIFY-PATHNAME" "UNIX-KILLPG"
@@ -1954,8 +1965,9 @@
 	       "ANY-REG-SC-NUMBER" "ARRAY-DATA-SLOT" "ARRAY-DIMENSIONS-OFFSET"
 	       "ARRAY-DISPLACED-P-SLOT" "ARRAY-DISPLACEMENT-SLOT"
 	       "ARRAY-ELEMENTS-SLOT" "ARRAY-FILL-POINTER-P-SLOT"
-	       "ARRAY-FILL-POINTER-SLOT" "ATOMIC-FLAG" "BASE-CHAR-REG-SC-NUMBER"
-	       "BASE-CHAR-STACK-SC-NUMBER" "BASE-CHAR-WIDETAG"
+	       "ARRAY-FILL-POINTER-SLOT" "ATOMIC-FLAG"
+	       "CHARACTER-REG-SC-NUMBER"
+	       "CHARACTER-STACK-SC-NUMBER" "CHARACTER-WIDETAG"
 	       "BIGNUM-DIGITS-OFFSET" "BIGNUM-WIDETAG" "BINDING-SIZE"
 	       "BINDING-SYMBOL-SLOT" "BINDING-VALUE-SLOT" "BREAKPOINT-TRAP"
 	       "N-BYTE-BITS" "BYTE-REG-SC-NUMBER"
@@ -1984,7 +1996,8 @@
 	       "COMPLEX-SINGLE-FLOAT-IMAG-SLOT" "COMPLEX-SINGLE-FLOAT-REAL-SLOT"
 	       "COMPLEX-SINGLE-FLOAT-SIZE" "COMPLEX-SINGLE-FLOAT-WIDETAG"
 	       "COMPLEX-SINGLE-REG-SC-NUMBER" "COMPLEX-SINGLE-STACK-SC-NUMBER"
-	       "COMPLEX-SIZE" "COMPLEX-BASE-STRING-WIDETAG" "COMPLEX-WIDETAG"
+	       "COMPLEX-SIZE" "COMPLEX-BASE-STRING-WIDETAG"
+	       "COMPLEX-CHARACTER-STRING-WIDETAG" "COMPLEX-WIDETAG"
 	       "COMPLEX-VECTOR-NIL-WIDETAG"
 	       "COMPLEX-VECTOR-WIDETAG" "CONS-CAR-SLOT" "CONS-CDR-SLOT"
 	       "CONS-SIZE" "CONSTANT-SC-NUMBER"
@@ -2034,7 +2047,7 @@
 	       "FUNCALLABLE-INSTANCE-LAYOUT-SLOT"
 	       "FUNCALLABLE-INSTANCE-LEXENV-SLOT"
 	       "GENESIS" "HALT-TRAP" "IGNORE-ME-SC-NUMBER"
-	       "IMMEDIATE-BASE-CHAR-SC-NUMBER" "IMMEDIATE-SAP-SC-NUMBER"
+	       "IMMEDIATE-CHARACTER-SC-NUMBER" "IMMEDIATE-SAP-SC-NUMBER"
 	       "IMMEDIATE-SC-NUMBER" "*INITIAL-DYNAMIC-SPACE-FREE-POINTER*"
 	       "INSTANCE-HEADER-WIDETAG" "INSTANCE-POINTER-LOWTAG"
 	       "INSTANCE-SLOTS-OFFSET" "INSTANCE-USAGE"
@@ -2124,6 +2137,7 @@
 	       "SIMPLE-ARRAY-SIGNED-BYTE-8-WIDETAG"
 	       "SIMPLE-BIT-VECTOR-WIDETAG"
 	       "SIMPLE-BASE-STRING-WIDETAG"
+	       "SIMPLE-CHARACTER-STRING-WIDETAG"
 	       "SIMPLE-VECTOR-WIDETAG" "SINGLE-FLOAT-BIAS"
 	       "SINGLE-FLOAT-DIGITS" "SINGLE-FLOAT-EXPONENT-BYTE"
 	       "SINGLE-FLOAT-HIDDEN-BIT" "SINGLE-FLOAT-NORMAL-EXPONENT-MAX"
diff -urN sbcl-0.8.16/src/code/ansi-stream.lisp sbcl-0.8.16.patched/src/code/ansi-stream.lisp
--- sbcl-0.8.16/src/code/ansi-stream.lisp	2002-01-16 00:53:51.000000000 +0100
+++ sbcl-0.8.16.patched/src/code/ansi-stream.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -89,6 +89,9 @@
 (deftype ansi-stream-in-buffer ()
   `(simple-array (unsigned-byte 8) (,+ansi-stream-in-buffer-length+)))
 
+(deftype ansi-stream-cin-buffer ()
+  `(simple-array character (,+ansi-stream-in-buffer-length+)))
+
 ;;; base class for ANSI standard streams (as opposed to the Gray
 ;;; streams extension)
 (defstruct (ansi-stream (:constructor nil)
@@ -100,6 +103,7 @@
   ;; slot must must be NIL, and the IN-INDEX must be
   ;; +ANSI-STREAM-IN-BUFFER-LENGTH+.)
   (in-buffer nil :type (or ansi-stream-in-buffer null))
+  (cin-buffer nil :type (or ansi-stream-cin-buffer null))
   (in-index +ansi-stream-in-buffer-length+ :type index)
 
   ;; buffered input functions
diff -urN sbcl-0.8.16/src/code/array.lisp sbcl-0.8.16.patched/src/code/array.lisp
--- sbcl-0.8.16/src/code/array.lisp	2004-05-31 02:21:29.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/array.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -93,6 +93,8 @@
      (values #.sb!vm:simple-vector-widetag #.sb!vm:n-word-bits))
     ((base-char standard-char)
      (values #.sb!vm:simple-base-string-widetag #.sb!vm:n-byte-bits))
+    ((character)
+     (values #.sb!vm:simple-character-string-widetag #.sb!vm:n-word-bits))
     ((bit)
      (values #.sb!vm:simple-bit-vector-widetag 1))
     ;; OK, we have to wade into SUBTYPEPing after all.
@@ -112,6 +114,8 @@
      #.sb!vm:complex-vector-widetag)
     ((base-char)
      #.sb!vm:complex-base-string-widetag)
+    ((character)
+     #.sb!vm:complex-character-string-widetag)
     ((nil)
      #.sb!vm:complex-vector-nil-widetag)
     ((bit)
@@ -121,6 +125,7 @@
      (pick-vector-type type
        (nil #.sb!vm:complex-vector-nil-widetag)
        (base-char #.sb!vm:complex-base-string-widetag)
+       (character #.sb!vm:complex-character-string-widetag)
        (bit #.sb!vm:complex-bit-vector-widetag)
        (t #.sb!vm:complex-vector-widetag)))))
 
@@ -148,7 +153,8 @@
 		 (array (allocate-vector
 			 type
 			 length
-			 (ceiling (* (if (= type sb!vm:simple-base-string-widetag)
+			 (ceiling (* (if (or (= type sb!vm:simple-base-string-widetag)
+					     (= type sb!vm:simple-character-string-widetag))
 					 (1+ length)
 					 length)
 				     n-bits)
@@ -158,13 +164,13 @@
 	      (fill array initial-element))
 	    (when initial-contents-p
 	      (when initial-element-p
-		(error "can't specify both :INITIAL-ELEMENT and ~
-		:INITIAL-CONTENTS"))
-	      (unless (= length (length initial-contents))
-		(error "There are ~W elements in the :INITIAL-CONTENTS, but ~
-		       the vector length is ~W."
-		       (length initial-contents)
-		       length))
+                (error "can't specify both :INITIAL-ELEMENT and ~
+                :INITIAL-CONTENTS"))
+              (unless (= length (length initial-contents))
+                (error "There are ~W elements in the :INITIAL-CONTENTS, but ~
+                       the vector length is ~W."
+                       (length initial-contents)
+                       length))
 	      (replace array initial-contents))
 	    array))
 	;; it's either a complex array or a multidimensional array.
@@ -205,7 +211,7 @@
 	  (cond (displaced-to
 		 (when (or initial-element-p initial-contents-p)
 		   (error "Neither :INITIAL-ELEMENT nor :INITIAL-CONTENTS ~
-		   can be specified along with :DISPLACED-TO"))
+                   can be specified along with :DISPLACED-TO"))
 		 (let ((offset (or displaced-index-offset 0)))
 		   (when (> (+ offset total-size)
 			    (array-total-size displaced-to))
@@ -229,7 +235,7 @@
                                initial-element initial-element-p)
   (when (and initial-contents-p initial-element-p)
     (error "cannot supply both :INITIAL-CONTENTS and :INITIAL-ELEMENT to
-	    either MAKE-ARRAY or ADJUST-ARRAY."))
+            either MAKE-ARRAY or ADJUST-ARRAY."))
   (let ((data (if initial-element-p
 		  (make-array total-size
 			      :element-type element-type
@@ -254,13 +260,13 @@
 		      (incf index))
 		     (t
 		      (unless (typep contents 'sequence)
-			(error "malformed :INITIAL-CONTENTS: ~S is not a ~
-				sequence, but ~W more layer~:P needed."
+                        (error "malformed :INITIAL-CONTENTS: ~S is not a ~
+                                sequence, but ~W more layer~:P needed."
 			       contents
 			       (- (length dimensions) axis)))
 		      (unless (= (length contents) (car dims))
-			(error "malformed :INITIAL-CONTENTS: Dimension of ~
-				axis ~W is ~W, but ~S is ~W long."
+                        (error "malformed :INITIAL-CONTENTS: Dimension of ~
+                                axis ~W is ~W, but ~S is ~W long."
 			       axis (car dims) contents (length contents)))
 		      (if (listp contents)
 			  (dolist (content contents)
@@ -708,8 +714,8 @@
       (cond (initial-contents-p
 	     ;; array former contents replaced by INITIAL-CONTENTS
 	     (if (or initial-element-p displaced-to)
-		 (error "INITIAL-CONTENTS may not be specified with ~
-		 the :INITIAL-ELEMENT or :DISPLACED-TO option."))
+                 (error "INITIAL-CONTENTS may not be specified with ~
+                         the :INITIAL-ELEMENT or :DISPLACED-TO option."))
 	     (let* ((array-size (apply #'* dimensions))
 		    (array-data (data-vector-from-inits
 				 dimensions array-size element-type
@@ -729,11 +735,11 @@
 	    (displaced-to
 	     ;; We already established that no INITIAL-CONTENTS was supplied.
 	     (when initial-element
-	       (error "The :INITIAL-ELEMENT option may not be specified ~
-	              with :DISPLACED-TO."))
-	     (unless (subtypep element-type (array-element-type displaced-to))
-	       (error "can't displace an array of type ~S into another of ~
-		       type ~S"
+               (error "The :INITIAL-ELEMENT option may not be specified ~
+                       with :DISPLACED-TO."))
+             (unless (subtypep element-type (array-element-type displaced-to))
+               (error "can't displace an array of type ~S into another of ~
+                       type ~S"
 		      element-type (array-element-type displaced-to)))
 	     (let ((displacement (or displaced-index-offset 0))
 		   (array-size (apply #'* dimensions)))
@@ -813,19 +819,19 @@
 	 (when (array-has-fill-pointer-p old-array)
 	   (when (> (%array-fill-pointer old-array) new-array-size)
 	     (error "cannot ADJUST-ARRAY an array (~S) to a size (~S) that is ~
-		    smaller than its fill pointer (~S)"
+                     smaller than its fill pointer (~S)"
 		    old-array new-array-size (fill-pointer old-array)))
 	   (%array-fill-pointer old-array)))
 	((not (array-has-fill-pointer-p old-array))
 	 (error "cannot supply a non-NIL value (~S) for :FILL-POINTER ~
-		in ADJUST-ARRAY unless the array (~S) was originally ~
- 		created with a fill pointer"
+                 in ADJUST-ARRAY unless the array (~S) was originally ~
+                 created with a fill pointer"
 		fill-pointer
 		old-array))
 	((numberp fill-pointer)
 	 (when (> fill-pointer new-array-size)
 	   (error "can't supply a value for :FILL-POINTER (~S) that is larger ~
-		  than the new length of the vector (~S)"
+                   than the new length of the vector (~S)"
 		  fill-pointer new-array-size))
 	 fill-pointer)
 	((eq fill-pointer t)
@@ -854,7 +860,8 @@
 	  ,@(map 'list
 		 (lambda (saetp)
 		   `((simple-array ,(sb!vm:saetp-specifier saetp) (*))
-		     ,(if (eq (sb!vm:saetp-specifier saetp) 'base-char)
+		     ,(if (or (eq (sb!vm:saetp-specifier saetp) 'character)
+			      (eq (sb!vm:saetp-specifier saetp) 'base-char))
 			  *default-init-char-form*
 			  (sb!vm:saetp-initial-element-default saetp))))
 		 (remove-if-not
@@ -995,10 +1002,10 @@
      #!+sb-doc
      ,(format nil
 	      "Perform a bit-wise ~A on the elements of BIT-ARRAY-1 and ~
-	      BIT-ARRAY-2,~%  putting the results in RESULT-BIT-ARRAY. ~
-	      If RESULT-BIT-ARRAY is T,~%  BIT-ARRAY-1 is used. If ~
-	      RESULT-BIT-ARRAY is NIL or omitted, a new array is~%  created. ~
-	      All the arrays must have the same rank and dimensions."
+               BIT-ARRAY-2,~%  putting the results in RESULT-BIT-ARRAY. ~
+               If RESULT-BIT-ARRAY is T,~%  BIT-ARRAY-1 is used. If ~
+               RESULT-BIT-ARRAY is NIL or omitted, a new array is~%  created. ~
+               All the arrays must have the same rank and dimensions."
 	      (symbol-name function))
      (declare (type (array bit) bit-array-1 bit-array-2)
 	      (type (or (array bit) (member t nil)) result-bit-array))
diff -urN sbcl-0.8.16/src/code/char.lisp sbcl-0.8.16.patched/src/code/char.lisp
--- sbcl-0.8.16/src/code/char.lisp	2002-05-19 15:55:31.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/char.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -12,6 +12,8 @@
 
 (in-package "SB!IMPL")
 
-(def!constant sb!xc:char-code-limit 256
+(def!constant sb!xc:char-code-limit #x110000
   #!+sb-doc
   "the upper exclusive bound on values produced by CHAR-CODE")
+
+(def!constant base-char-code-limit 128)
diff -urN sbcl-0.8.16/src/code/class.lisp sbcl-0.8.16.patched/src/code/class.lisp
--- sbcl-0.8.16/src/code/class.lisp	2004-08-10 02:20:45.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/class.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -358,8 +358,8 @@
 			      inherits
 			      :key #'layout-proper-name)
 		(warn "change in superclasses of class ~S:~%  ~
-		       ~A superclasses: ~S~%  ~
-		       ~A superclasses: ~S"
+                       ~A superclasses: ~S~%  ~
+                       ~A superclasses: ~S"
 		      name
 		      old-context
 		      (map 'list #'layout-proper-name old-inherits)
@@ -370,8 +370,8 @@
 		(when diff
 		  (warn
 		   "in class ~S:~%  ~
-		    ~:(~A~) definition of superclass ~S is incompatible with~%  ~
-		    ~A definition."
+                    ~:(~A~) definition of superclass ~S is incompatible with~%  ~
+                    ~A definition."
 		   name
 		   old-context
 		   (layout-proper-name (svref old-inherits diff))
@@ -380,15 +380,15 @@
 	(let ((old-length (layout-length old-layout)))
 	  (unless (= old-length length)
 	    (warn "change in instance length of class ~S:~%  ~
-		   ~A length: ~W~%  ~
-		   ~A length: ~W"
+                   ~A length: ~W~%  ~
+                   ~A length: ~W"
 		  name
 		  old-context old-length
 		  context length)
 	    t))
 	(unless (= (layout-depthoid old-layout) depthoid)
 	  (warn "change in the inheritance structure of class ~S~%  ~
-		 between the ~A definition and the ~A definition"
+                 between the ~A definition and the ~A definition"
 		name old-context context)
 	  t))))
 
@@ -415,7 +415,7 @@
     ;; system from scratch, so we no longer need this functionality in
     ;; order to maintain the SBCL system by modifying running images.
     (error "The class ~S was not changed, and there's no guarantee that~@
-	    the loaded code (which expected another layout) will work."
+            the loaded code (which expected another layout) will work."
 	   (layout-proper-name layout)))
   (values))
 
@@ -931,8 +931,11 @@
   (setq
    *built-in-classes*
    '((t :state :read-only :translation t)
-     (character :enumerable t :translation base-char
+     (character :enumerable t
+                :codes (#.sb!vm:character-widetag)
+                :translation (character-set)
                 :prototype-form (code-char 42))
+     #+nil
      (base-char :enumerable t
 		:inherits (character)
 		:codes (#.sb!vm:base-char-widetag)
@@ -1241,6 +1244,19 @@
       :inherits (base-string simple-string string vector simple-array
 		 array sequence)
       :prototype-form (make-array 0 :element-type 'base-char))
+     (character-string
+      :translation (vector character)
+      :codes (#.sb!vm:complex-character-string-widetag)
+      :direct-superclasses (string)
+      :inherits (string vector array sequence)
+      :prototype-form (make-array 0 :element-type 'character :fill-pointer t))
+     (simple-character-string
+      :translation (simple-array character (*))
+      :codes (#.sb!vm:simple-character-string-widetag)
+      :direct-superclasses (character-string simple-string)
+      :inherits (character-string simple-string string vector simple-array
+		 array sequence)
+      :prototype-form (make-array 0 :element-type 'character))
      (list
       :translation (or cons (member nil))
       :inherits (sequence))
diff -urN sbcl-0.8.16/src/code/cold-init.lisp sbcl-0.8.16.patched/src/code/cold-init.lisp
--- sbcl-0.8.16/src/code/cold-init.lisp	2004-09-09 14:10:13.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/cold-init.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -111,6 +111,8 @@
   ;; this to be initialized, so we initialize it right away.
   (show-and-call !random-cold-init)
 
+  (show-and-call !character-database-cold-init)
+
   (show-and-call !early-package-cold-init)
   (show-and-call !package-cold-init)
   
@@ -313,7 +315,7 @@
 (defun hexstr (thing)
   (/noshow0 "entering HEXSTR")
   (let ((addr (get-lisp-obj-address thing))
-	(str (make-string 10)))
+	(str (make-string 10 :element-type 'base-char)))
     (/noshow0 "ADDR and STR calculated")
     (setf (char str 0) #\0
 	  (char str 1) #\x)
diff -urN sbcl-0.8.16/src/code/cross-char.lisp sbcl-0.8.16.patched/src/code/cross-char.lisp
--- sbcl-0.8.16/src/code/cross-char.lisp	2003-07-02 10:36:57.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/cross-char.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -20,7 +20,6 @@
 	(char ascii-standard-chars (- x 32))))
   (defun sb!xc:char-code (character)
     (declare (type standard-char character))
-    ;; FIXME: MacOS X?
     (if (char= character #\Newline)
 	10
 	(+ (position character ascii-standard-chars) 32))))
diff -urN sbcl-0.8.16/src/code/cross-condition.lisp sbcl-0.8.16.patched/src/code/cross-condition.lisp
--- sbcl-0.8.16/src/code/cross-condition.lisp	2004-09-15 21:48:33.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/cross-condition.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -31,6 +31,9 @@
 (define-condition reference-condition ()
   ((references :initarg :references :reader reference-condition-references)))
 
+;;; KLUDGE
+(define-condition type-warning (simple-warning) ())
+
 (define-condition bug (simple-error)
   ()
   (:report
diff -urN sbcl-0.8.16/src/code/cross-type.lisp sbcl-0.8.16.patched/src/code/cross-type.lisp
--- sbcl-0.8.16/src/code/cross-type.lisp	2003-08-14 19:16:12.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/cross-type.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -82,6 +82,9 @@
 		  'fixnum)
 		 (t
 		  'integer)))
+          ((subtypep raw-result 'simple-string)
+           `(simple-base-string ,(length object)))
+          ((subtypep raw-result 'string) 'base-string)
 	  ((some (lambda (type) (subtypep raw-result type))
 		 '(array character list symbol))
 	   raw-result)
@@ -360,6 +363,11 @@
      (make-member-type :members (list x)))
     (number
      (ctype-of-number x))
+    (string
+     (make-array-type :dimensions (array-dimensions x)
+                      :complexp (not (typep x 'simple-array))
+                      :element-type (specifier-type 'base-char)
+                      :specialized-element-type (specifier-type 'base-char)))
     (array
      (let ((etype (specifier-type (array-element-type x))))
        (make-array-type :dimensions (array-dimensions x)
@@ -369,9 +377,7 @@
     (cons (specifier-type 'cons))
     (character
      (cond ((typep x 'standard-char)
-	    ;; (Note that SBCL doesn't distinguish between BASE-CHAR and
-	    ;; CHARACTER.)
-	    (find-classoid 'base-char))
+	    (specifier-type 'character))
 	   ((not (characterp x))
 	    nil)
 	   (t
diff -urN sbcl-0.8.16/src/code/debug-int.lisp sbcl-0.8.16.patched/src/code/debug-int.lisp
--- sbcl-0.8.16/src/code/debug-int.lisp	2004-09-09 14:10:13.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/debug-int.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -64,8 +64,8 @@
 			 (no-debug-fun-returns-debug-fun condition))))
 	       (format stream
 		       "~&Cannot return values from ~:[frame~;~:*~S~] since ~
-			the debug information lacks details about returning ~
-			values here."
+                        the debug information lacks details about returning ~
+                        values here."
 		       fun)))))
 
 (define-condition no-debug-blocks (debug-condition)
@@ -2000,7 +2000,7 @@
        (zerop (logand val 3))
        ;; character
        (and (zerop (logand val #xffff0000)) ; Top bits zero
-	    (= (logand val #xff) sb!vm:base-char-widetag)) ; char tag
+	    (= (logand val #xff) sb!vm:character-widetag)) ; char tag
        ;; unbound marker
        (= val sb!vm:unbound-marker-widetag)
        ;; pointer
@@ -2055,7 +2055,7 @@
        (sb!sys:without-gcing
         (with-escaped-value (val) (sb!kernel:make-lisp-obj val))))
                             
-      (#.sb!vm:base-char-reg-sc-number
+      (#.sb!vm:character-reg-sc-number
        (with-escaped-value (val)
          (code-char val)))
       (#.sb!vm:sap-reg-sc-number
@@ -2145,7 +2145,7 @@
                                       sb!vm:n-word-bytes)))))
       (#.sb!vm:control-stack-sc-number
        (sb!kernel:stack-ref fp (sb!c:sc-offset-offset sc-offset)))
-      (#.sb!vm:base-char-stack-sc-number
+      (#.sb!vm:character-stack-sc-number
        (with-nfp (nfp)
          (code-char (sb!sys:sap-ref-32 nfp (* (sb!c:sc-offset-offset sc-offset)
                                               sb!vm:n-word-bytes)))))
@@ -2190,7 +2190,7 @@
        (without-gcing
 	(with-escaped-value (val)
 	  (make-valid-lisp-obj val))))
-      (#.sb!vm:base-char-reg-sc-number
+      (#.sb!vm:character-reg-sc-number
        (with-escaped-value (val)
 	 (code-char val)))
       (#.sb!vm:sap-reg-sc-number
@@ -2249,7 +2249,7 @@
 			       sb!vm:n-word-bytes)))))
       (#.sb!vm:control-stack-sc-number
        (stack-ref fp (sb!c:sc-offset-offset sc-offset)))
-      (#.sb!vm:base-char-stack-sc-number
+      (#.sb!vm:character-stack-sc-number
        (code-char
 	(sap-ref-32 fp (- (* (1+ (sb!c:sc-offset-offset sc-offset))
 			     sb!vm:n-word-bytes)))))
@@ -2330,7 +2330,7 @@
        (without-gcing
 	(set-escaped-value
 	  (get-lisp-obj-address value))))
-      (#.sb!vm:base-char-reg-sc-number
+      (#.sb!vm:character-reg-sc-number
        (set-escaped-value (char-code value)))
       (#.sb!vm:sap-reg-sc-number
        (set-escaped-value (sap-int value)))
@@ -2429,7 +2429,7 @@
 	       (the long-float (realpart value)))))
       (#.sb!vm:control-stack-sc-number
        (setf (stack-ref fp (sb!c:sc-offset-offset sc-offset)) value))
-      (#.sb!vm:base-char-stack-sc-number
+      (#.sb!vm:character-stack-sc-number
        (with-nfp (nfp)
 	 (setf (sap-ref-32 nfp (* (sb!c:sc-offset-offset sc-offset)
 					 sb!vm:n-word-bytes))
@@ -2464,7 +2464,7 @@
        (without-gcing
 	(set-escaped-value
 	  (get-lisp-obj-address value))))
-      (#.sb!vm:base-char-reg-sc-number
+      (#.sb!vm:character-reg-sc-number
        (set-escaped-value (char-code value)))
       (#.sb!vm:sap-reg-sc-number
        (set-escaped-value (sap-int value)))
@@ -2528,7 +2528,7 @@
 	     (imagpart (the (complex long-float) value))))
       (#.sb!vm:control-stack-sc-number
        (setf (stack-ref fp (sb!c:sc-offset-offset sc-offset)) value))
-      (#.sb!vm:base-char-stack-sc-number
+      (#.sb!vm:character-stack-sc-number
        (setf (sap-ref-32 fp (- (* (1+ (sb!c:sc-offset-offset sc-offset))
 					 sb!vm:n-word-bytes)))
 	     (char-code (the character value))))
@@ -2816,7 +2816,7 @@
 		     (compiled-debug-fun-compiler-debug-fun what))
 		    :standard)
 	  (error ":FUN-END breakpoints are currently unsupported ~
-		  for the known return convention."))
+                  for the known return convention."))
 
 	(let* ((bpt (%make-breakpoint hook-fun what kind info))
 	       (starter (compiled-debug-fun-end-starter what)))
diff -urN sbcl-0.8.16/src/code/defpackage.lisp sbcl-0.8.16.patched/src/code/defpackage.lisp
--- sbcl-0.8.16/src/code/defpackage.lisp	2004-06-29 10:50:58.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/defpackage.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -154,15 +154,15 @@
       for z = (remove-duplicates (intersection (cdr x)(cdr y) :test #'string=))
       when z do (error 'simple-program-error
 		       :format-control "Parameters ~S and ~S must be disjoint ~
-					but have common elements ~%   ~S"
+                                        but have common elements ~%   ~S"
 		       :format-arguments (list (car x)(car y) z)))))
 
 (defun stringify-name (name kind)
   (typecase name
-    (simple-base-string name)
-    (string (coerce name 'simple-base-string))
+    (simple-string name)
+    (string (coerce name 'simple-string))
     (symbol (symbol-name name))
-    (base-char (string name))
+    (character (string name))
     (t
      (error "bogus ~A name: ~S" kind name))))
 
@@ -173,11 +173,11 @@
 
 (defun %defpackage (name nicknames size shadows shadowing-imports
 		    use imports interns exports implement lock doc-string)
-  (declare (type simple-base-string name)
+  (declare (type simple-string name)
 	   (type list nicknames shadows shadowing-imports
 		 imports interns exports)
 	   (type (or list (member :default)) use)
-	   (type (or simple-base-string null) doc-string)
+	   (type (or simple-string null) doc-string)
 	   #!-sb-package-locks
 	   (ignore implement lock))
   (let ((package (or (find-package name)
diff -urN sbcl-0.8.16/src/code/deftypes-for-target.lisp sbcl-0.8.16.patched/src/code/deftypes-for-target.lisp
--- sbcl-0.8.16/src/code/deftypes-for-target.lisp	2004-03-01 21:30:24.000000000 +0100
+++ sbcl-0.8.16.patched/src/code/deftypes-for-target.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -60,6 +60,9 @@
 
 (sb!xc:deftype atom () '(not cons))
 
+(sb!xc:deftype base-char ()
+  '(character-set ((0 . #.(1- base-char-code-limit)))))
+
 (sb!xc:deftype extended-char ()
   #!+sb-doc
   "Type of CHARACTERs that aren't BASE-CHARs."
@@ -69,9 +72,9 @@
   #!+sb-doc
   "Type corresponding to the characters required by the standard."
   '(member
-    #\NEWLINE #\SPACE #\! #\" #\# #\$ #\% #\& #\' #\( #\) #\* #\+ #\,
+    #\Newline #\Space #\! #\" #\# #\$ #\% #\& #\' #\( #\) #\* #\+ #\,
     #\- #\. #\/ #\0 #\1 #\2 #\3 #\4 #\5 #\6 #\7 #\8 #\9 #\: #\; #\< #\=
-    #\> #\?  #\@ #\A #\B #\C #\D #\E #\F #\G #\H #\I #\J #\K #\L #\M
+    #\> #\? #\@ #\A #\B #\C #\D #\E #\F #\G #\H #\I #\J #\K #\L #\M
     #\N #\O #\P #\Q #\R #\S #\T #\U #\V #\W #\X #\Y #\Z #\[ #\\ #\]
     #\^ #\_ #\` #\a #\b #\c #\d #\e #\f #\g #\h #\i #\j #\k #\l #\m
     #\n #\o #\p #\q #\r #\s #\t #\u #\v #\w #\x #\y #\z #\{
